#import "WFWCar.h"
#import <space.h>
#import <random.h>
#import "Detector.h"

@implementation WFWCar

//---------------------
-(void)setLeadingCar: aCar
{
	myLeadingCar = aCar;
}

-(int)getX
{
	return myX;
}

-(int)getV
{
	return myV;
}

-(int)getTempV
{
	return myTempV;
}


//---------------------
-(void)accelerate
{
	myTempV = myV;
	if (myTempV < myVMax) ++myTempV;
}

-(void)brake1
{
	int t;

	myHeadway = [myLeadingCar getX] - myX;
	if (myHeadway<0) myHeadway += myWorldSize;
	t = myHeadway - 1 + [myLeadingCar getV];
	if (t < myTempV) myTempV = t;
}

-(void)randomize
{
	if (myTempV > 0
		&& [uniformIntRand getIntegerWithMin: 1 withMax: 100] <= myPDecel*100)
		--myTempV;
}

-(void)brake2
{
	int t;

	t = myHeadway - 1 + [myLeadingCar getTempV];
	if (t < myTempV) myTempV = t;
}

-(void)drive
{
	int newX;
	
	myV = myTempV;
	newX = myX + myV;
	if (newX >= myWorldSize) newX -= myWorldSize;
	[myWorld putObject: nil atX: myX Y: myY];
	[myWorld putObject: self atX: newX Y: myY];
	if (myX < myDetX && newX >= myDetX)
		[myDetector trigger];
	myX = newX;
}


